require 'puppet/resource_api'

Puppet::ResourceApi.register_type(
  name: 'dsc_coctopusserverwatchdog',
  dscmeta_resource_friendly_name: 'cOctopusServerWatchdog',
  dscmeta_resource_name: 'cOctopusServerWatchdog',
  dscmeta_module_name: 'OctopusDSC',
  dscmeta_module_version: '2.0.143',
  docs: 'The DSC cOctopusServerWatchdog resource type.
         Automatically generated from version 2.0.143',
  features: ['simple_get_filter', 'canonicalize', 'custom_insync'],
  attributes: {
    name: {
      type:      'String',
      desc:      'Description of the purpose for this resource declaration.',
      behaviour: :namevar,
    },
    validation_mode: {
      type:      'Enum[property, resource]',
      desc:      'Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode (resource).',
      behaviour: :parameter,
      default:   'property',
    },
    dsc_instancename: {
      type: 'String',
      desc: 'Name of the Octopus Server instance',
      behaviour: :namevar,
      mandatory_for_get: true,
      mandatory_for_set: true,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_interval: {
      type: 'Optional[Integer[0, 4294967295]]',
      desc: 'The interval in minutes. Defaults to checking every 15 minutes.',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'UInt32',
      mof_is_embedded: false,
    },
    dsc_psdscrunascredential: {
      type: 'Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]',
      desc: ' ',
      behaviour: :parameter,
      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'PSCredential',
      mof_is_embedded: true,
    },
    dsc_instances: {
      type: 'Optional[String]',
      desc: "Which instances to check. Use '*' to check all instances.",

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_enabled: {
      type: 'Optional[Boolean]',
      desc: 'True to enable watchdog, false to disable',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'Boolean',
      mof_is_embedded: false,
    },
  },
)
